<?php

// Секретный ключ системы поощрений
const SECRET = '9ccd453dc889d7e132c31d1d99d6d8a3';

// Адрес подключения к базе данных
const DB_HOST = '127.0.0.1';

// Порт подключения к базе данных
const DB_PORT = 3306;

// Имя пользователя баз данных
const DB_USERNAME = 'root';

// Пароль пользователя баз данных
const DB_PASSWORD = '';

// Имя базы данных
const DB_DATABASE = 'minecraft';

// Кодировка соединения с базой данных
const DB_CHARSET = 'utf8mb4';

// Таблица пользователей в базе данных
const DB_TABLE = 'users';

// Колонка ника игрока в таблице
const DB_TABLE_USERNAME_COLUMN = 'player';

// Колонка баланса игрока в таблице
const DB_TABLE_BALANCE_COLUMN = 'balance';

// Таймаут соединения с базой данных в секундах
const DB_TIMEOUT = 3;

// Сколько денег будет начислено за голос
const MONEY = 1000;





// Выставляем системные настройки PHP
ini_set('mysql.connect_timeout', DB_TIMEOUT);
ini_set('display_errors', 1);
error_reporting(E_ALL);

header('Content-Type: text/html; charset=UTF-8');

// Проверяем, что метод отправки POST
if($_SERVER["REQUEST_METHOD"] != 'POST'){
    exit('Invalid request');
}

// Генерируем сигнатуру
$sign = md5(implode(':', [
    @$_POST['project_id'],
    @$_POST['player'],
    @$_POST['votes'],
    @$_POST['date'],
    SECRET
]));

// Сверяем сигнатуру
if($sign !== @$_POST['sign']){
    exit('Invalid sign');
}



// Создаем соединение с базой данных MySQL
$connection =  new mysqli(DB_HOST, DB_USERNAME, DB_PASSWORD, DB_DATABASE, DB_PORT);

// Проверяем, есть ли ошибки соединения. Если есть, то выходим из скрипта и выводим ошибку
if($connection->connect_errno){
	exit("MySQLi connection error: ".$connection->connect_error);
}

// Проверяем, есть ли ошибки выставления опций. Если есть, то выходим из скрипта и выводим ошибку
if(!@$connection->options(MYSQLI_OPT_CONNECT_TIMEOUT, DB_TIMEOUT)){
	exit("MySQLi error set options: ".$connection->connect_error);
}


// Проверяем, есть ли ошибки выставления кодировки. Если есть, то выходим из скрипта и выводим ошибку
if(!@$connection->set_charset(DB_CHARSET)){
	exit("MySQLi change database charset error: ".$connection->error);
}

// Защищаем входящие данные от SQL инъекций
$username = $connection->escape_string($_POST['player']);

// Обновляем баланс игрока
$update = $connection->query("UPDATE `".DB_TABLE."`
                                SET `".DB_TABLE_BALANCE_COLUMN."` = `".DB_TABLE_BALANCE_COLUMN."` + ".MONEY."
                                WHERE `".DB_TABLE_USERNAME_COLUMN."` = '{$username}'
                                LIMIT 1");

// В случае ошибок завершаем скрипт и выводим ошибку
if(!$update){ exit('SQL Error: '.$connection->error); }


exit('YES');